	<template>

    <!-- Wrapper -->
	<div id="wrapper">
		<section class="fullwidth border-top margin-top-70 padding-top-75 padding-bottom-75" data-background-color="#fff">
			<div class="container">

				<div class="row">
					<div class="col-md-12">
						<h3 class="headline centered margin-bottom-45">
							Welcome to our Outfit Adviser Payment Page
						</h3>
					</div>     
				</div>

				<div class="row">
					<!-- Blog Post Item -->
					<div class="col-md-4">
						<a class="blog-compact-item-container">
							<div class="blog-compact-item">
								<img src="/static/images/ethereum.png" alt="">
								<div class="blog-compact-item-content">
									<h3>1 Week Token/0.1 ETHERS</h3>
									<p>This token is valid for one week from date of purchase</p>
                                    <div class="col-md-12 centered-content">
						                <a class="button margin-top-10 btn-getToken"  @click="buy1WeekToken()">
                                        Pay for token</a>
					                </div>
								</div>
							</div>
						</a>
					</div>
					<!-- Blog post Item / End -->

					<!-- Blog Post Item -->
					<div class="col-md-4">
						<a class="blog-compact-item-container">
							<div class="blog-compact-item">
								<img src="/static/images/payment.jpg" alt="">
								<div class="blog-compact-item-content">
									<h3>1 Month Token/0.5 ETHERS</h3>
									<p>This token is valid for one month from date of purchase</p>
                                    <div class="col-md-12 centered-content">
						                <a class="button margin-top-10 btn-getToken" @click="buy1MonthToken()">
                                        Pay for token</a>
					                </div>
								</div>
							</div>
						</a>
					</div>
					<!-- Blog post Item / End -->

					<!-- Blog Post Item -->
					<div class="col-md-4">
						<a class="blog-compact-item-container">
							<div class="blog-compact-item">
								<img src="/static/images/clothes3.jpg" alt="">
								<div class="blog-compact-item-content">
									<h3>3 Months Token/0.8 ETHERS</h3>
									<p>This token is valid for three months from date of purchase</p>
									<div class="col-md-12 centered-content">
						                <a class="button margin-top-10 btn-getToken" @click="buy3MonthToken()">
                                        Pay for token</a>
					                </div>
                                </div>
							</div>
						</a>
					</div>
					<!-- Blog post Item / End -->

				</div>

		<div class="cover-spin" v-if="loading">
      <div class="circle-loading">
          <circle-8 style="margin-left: 25%;"></circle-8>
            <h3 style="color:#fff;margin-left: 70px;">Please wait until the process of payment is finished!</h3>
            <h4 style="color:#fff;margin-left: 150px;">You will be redirected to Outfit Adviser services</h4>
      </div>
				</div>

			</div>
		</section>

	</div>
	<!-- Wrapper / End -->
    </template>

<script>
import VueLocalStorage from "vue-localstorage";
import Vue from "vue";
import axios from "axios";
import swal from "sweetalert2";
import Circle8 from "vue-loading-spinner/src/components/Circle8";

Vue.use(VueLocalStorage);

var TruffleContract = require("truffle-contract");
var web3Provider = null;
var contracts = {};
var address = null;
var tokenDuration = null;
//var loading = false;

export default {
  name: "outfitAccess",
  components: {
    Circle8
  },
  data() {
    return {
      msg: "Welcome to Your Outfit Advisor",
      TruffleContract,
      loading: false
    };
  },
  mounted() {
    this.getAccounts(), this.initWeb3();
    //this.waitForReceipt(hash, cb);
  },
  methods: {
    waitForReceipt: function waitForReceipt(hash, cb) {
      web3.eth.getTransactionReceipt(hash, function(err, receipt) {
        if (err) {
          console.log(err);
        }

        if (receipt !== null) {
          // Transaction went through
          if (cb) {
            cb(receipt);
          }
        } else {
          // Try again in 1 second
          window.setTimeout(function() {
            waitForReceipt(hash, cb);
          }, 1000);
        }
      });
    },
    show() {
      this.$modal.show("hello-world");
    },
    hide() {
      this.$modal.hide("hello-world");
    },
    async getAccounts() {
      if (typeof web3 !== "undefined") {
        web3 = new Web3(web3.currentProvider);
      } else {
        // set the provider you want from Web3.providers
        web3 = new Web3(
          new Web3.providers.HttpProvider("http://localhost:8545")
        );
      }

      web3.eth.getAccounts(function(error, result) {
        if (error) {
          console.log(error);
        } else {
          address = result[0];
          console.log(address);
          //  document.getElementById("address").value = address;
        }
      });
    },

    async initWeb3() {
      // Is there an injected web3 instance?
      if (typeof web3 !== "undefined") {
        web3Provider = web3.currentProvider;
      } else {
        // If no injected web3 instance is detected, fall back to Ganache
        web3Provider = new Web3.providers.HttpProvider("http://localhost:7545");
      }
      web3 = new Web3(web3Provider);
      await this.initContract();
      //return App.initContract();
    },

    async initContract() {
      $.getJSON("/static/build/contracts/WeatherERC20Token.json", function(
        data
      ) {
        // Get the necessary contract artifact file and instantiate it with truffle-contract
        console.log(data);
        var WeatherArtifact = data;
        contracts.WeatherERC20Token = TruffleContract(WeatherArtifact);

        // Set the provider for our contract
        contracts.WeatherERC20Token.setProvider(web3Provider);
        // Use our contract to retrieve and mark the adopted pets
        //return App.markPaid();
      });
    },

    getBalance() {
      var payInstance;
      web3.eth.getAccounts(function(error, accounts) {
        if (error) {
          console.log(error);
        }

        var account = accounts[0];

        contracts.WeatherERC20Token.deployed()
          .then(function(instance) {
            payInstance = instance;
            var approved;

            return payInstance.balanceOf.call(account);
          })
          .then(function(result) {
            console.log(result.toNumber());
          })
          .catch(function(err) {
            console.log(err.message);
          });
      });
    },

    buy1WeekToken() {
      var self = this;
      var payInstance;
      var vm = this;

      web3.eth.getAccounts(function(error, accounts) {
        if (error) {
          console.log(error);
        }
        var account = accounts[0];
        var accountContract = "0xaa927CBd122714cDe73c3420E32e5A7664E0DD50";
        tokenDuration = 7;
        contracts.WeatherERC20Token.deployed()
          .then(function(instance) {
            payInstance = instance;
            var approved;

            if (Vue.localStorage.get("user") == null) {
              $(".btn-getToken").on("click", function() {
                swal({
                  type: "error",
                  title: "Oops...",
                  text: "Please Login to be able to buy tokens!"
                  //footer: "<a href>Why do I have this issue?</a>"
                });
              });
            } else {
              vm.loading = true;
              console.log(vm.loading);
              return payInstance
                .buy(web3.toWei(0.1, "ether"), {
                  from: account,
                  to: accountContract,
                  value: web3.toWei(0.1, "ether")
                })
                .then(function(hash) {
                  console.log(hash.tx);
                  self.waitForReceipt(hash, function(receipt) {
                    vm.loading = false;
                    axios
                      .post(
                        "http://34.244.196.28:443/users/tokenValidity/" +
                          address +
                          "/" +
                          tokenDuration +
                          "/" +
                          hash.tx
                      )
                      .then(response => {
                        axios
                          .get(
                            "http://34.244.196.28:443/users/refreshLocalStorage"
                          )
                          .then(response2 => {
                            Vue.localStorage.set(
                              "user",
                              JSON.stringify(response2)
                            );
                            console.log(JSON.stringify(response2));
                            self.$router.push("/outfit");
                          })
                          .catch(e => {
                            console.log(e);
                          });
                        console.log("c bon");
                      })
                      .catch(e => {
                        this.errors.push(e);
                      });
                  });
                });
            }
          })
          .then(function(result) {
            vm.loading = false;
            console.log("Transaction successful!");
          })
          .catch(function(err) {
            console.log(e);
          });
      });
    },
    buy1MonthToken() {
      var self = this;
      var payInstance;
      var vm = this;

      web3.eth.getAccounts(function(error, accounts) {
        if (error) {
          console.log(error);
        }

        var account = accounts[0];
        var accountContract = "0xaa927CBd122714cDe73c3420E32e5A7664E0DD50";
        tokenDuration = 30;
        contracts.WeatherERC20Token.deployed()
          .then(function(instance) {
            payInstance = instance;
            var approved;

            if (Vue.localStorage.get("user") == null) {
              $(".btn-getToken").on("click", function() {
                swal({
                  type: "error",
                  title: "Oops...",
                  text: "Please Login to be able to buy tokens!"
                  //footer: "<a href>Why do I have this issue?</a>"
                });
              });
            } else {
              vm.loading = true;
              console.log(vm.loading);
              return payInstance
                .buy(web3.toWei(0.2, "ether"), {
                  from: account,
                  to: accountContract,
                  value: web3.toWei(0.2, "ether")
                })
                .then(function(hash) {
                  console.log(hash.tx);
                  self.waitForReceipt(hash, function(receipt) {
                    vm.loading = false;
                    axios
                      .post(
                        "http://34.244.196.28:443/users/tokenValidity/" +
                          address +
                          "/" +
                          tokenDuration +
                          "/" +
                          hash.tx
                      )
                      .then(response => {
                        console.log("oooooooo"+response.data);
                        axios
                          .get(
                            "http://34.244.196.28:443/users/refreshLocalStorage"
                          )
                          .then(response2 => {
                            Vue.localStorage.set(
                              "user",
                              JSON.stringify(response2)
                            );
                            console.log(JSON.stringify(response2));
                            self.$router.push("/outfit");
                          })
                          .catch(e => {
                            console.log(e);
                          });
                        console.log("c bon");
                      })
                      .catch(e => {
                        console.log(e);
                      });
                  });
                });
            }
          })
          .then(function(result) {
            vm.loading = false;
            console.log("Transaction successful!");
          })
          .catch(function(err) {
            console.log(err.message);
          });
      });
    },
    buy3MonthToken() {
      var self = this;
      var payInstance;
      var vm = this;

      web3.eth.getAccounts(function(error, accounts) {
        if (error) {
          console.log(error);
        }

        var account = accounts[0];
        var accountContract = "0xaa927CBd122714cDe73c3420E32e5A7664E0DD50";
        tokenDuration = 90;
        contracts.WeatherERC20Token.deployed()
          .then(function(instance) {
            payInstance = instance;
            var approved;

            if (Vue.localStorage.get("user") == null) {
              $(".btn-getToken").on("click", function() {
                swal({
                  type: "error",
                  title: "Oops...",
                  text: "Please Login to be able to buy tokens!"
                  //footer: "<a href>Why do I have this issue?</a>"
                });
              });
            } else {
              vm.loading = true;
              console.log(vm.loading);
              return payInstance
                .buy(web3.toWei(0.5, "ether"), {
                  from: account,
                  to: accountContract,
                  value: web3.toWei(0.5, "ether")
                })
                .then(function(hash) {
                  console.log(hash.tx);
                  self.waitForReceipt(hash, function(receipt) {
                    vm.loading = false;
                    axios
                      .post(
                        "http://34.244.196.28:443/users/tokenValidity/" +
                          address +
                          "/" +
                          tokenDuration +
                          "/" +
                          hash.tx
                      )
                      .then(response => {
                        axios
                          .get(
                            "http://34.244.196.28:443/users/refreshLocalStorage"
                          )
                          .then(response2 => {
                            Vue.localStorage.set(
                              "user",
                              JSON.stringify(response2)
                            );
                            console.log(JSON.stringify(response2));
                            self.$router.push("/outfit");
                          })
                          .catch(e => {
                            console.log(e);
                          });
                        console.log("c bon");
                      })
                      .catch(e => {
                       console.log(e);
                      });
                  });
                });
            }
          })
          .then(function(result) {
            vm.loading = false;
            console.log("Transaction successful!");
          })
          .catch(function(err) {
            console.log(err.message);
          });
      });
    },
    transferToken() {
      var payInstance;

      web3.eth.getAccounts(function(error, accounts) {
        if (error) {
          console.log(error);
        }

        var account = "0x7Ca58F260d7a84FBe9ECa5575679a9a1b0a87B4b";
        var accountContract = "0xaa927CBd122714cDe73c3420E32e5A7664E0DD50";
        console.log(account);
        contracts.WeatherERC20Token.deployed()
          .then(function(instance) {
            payInstance = instance;

            return payInstance.transfer(accountContract, 98, { from: account });
          })
          .then(function(result) {})
          .catch(function(err) {
            console.log(err.message);
          });
      });
    }
  }
};
</script>

  <script2 src="../assets/javascripts/web3.min.js"></script2>
	<script2 src="../assets/javascripts/truffle-contract.js"></script2>
	<script2 type="text/javascript" src="../assets/javascripts/app.js"></script2>
